//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DimGray
#property indicator_color2 PaleVioletRed
#property indicator_width2 2
#property indicator_style1 STYLE_DOT

#import "fourier extrapolation.dll"
    void fourierExtrapolation(double& source[], double& past[], double& prediction[], int pastBars, int lastBar, int futureBars, int harmonicsNo, double harmonicsTolerance);
#import

//
//
//
//
//

extern int     Price      = PRICE_CLOSE;
extern int     LastBar    = 200;    // Last bar in the past data
extern int     PastBars   = 500;    // Number of past bars
extern int     FutBars    = 200;    // Number of bars to predict 
extern int     HarmNo     = 10;     // Number of frequencies; HarmNo=0 computes PastBars harmonics
extern double  FreqTOL    = 0.0001; // Tolerance of frequency calculation - FreqTOL > 0.001 may not converge

double indicatorValues[];
double pastValues[];
double futureValues[];

double source[];
double result[];
double prediction[];

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if(HarmNo==0 || HarmNo>PastBars) HarmNo=PastBars;

   IndicatorBuffers(3);
      SetIndexBuffer(0,pastValues);      SetIndexLabel(0,"past");
      SetIndexBuffer(1,futureValues);    SetIndexLabel(1,"prediction");
      SetIndexBuffer(2,indicatorValues); SetIndexLabel(2,"values");
   IndicatorShortName("Fourier extrapolation of WPR");
   return(0);
}
int deinit(){return(0);}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);

      int np = PastBars; if (np>Bars)    np = Bars;
      int nf = FutBars;  if (nf<LastBar) nf = LastBar;

      if (ArraySize(source)    !=np)   ArrayResize(source,np);
      if (ArraySize(result)    !=np)   ArrayResize(result,np);
      if (ArraySize(prediction)!=nf+1) ArrayResize(prediction,nf+1);
               SetIndexShift(0,  -LastBar);
               SetIndexShift(1,nf-LastBar);

      //
      //
      //
      //
      //

      for(int i=limit; i>=0; i--) indicatorValues[i]=iMA(NULL,0,1,0,MODE_SMA,Price,i);
         ArrayCopy(source,indicatorValues,0,LastBar,np);
            fourierExtrapolation(source,result,prediction,np,LastBar,nf+1,HarmNo,FreqTOL);
         ArrayCopy(pastValues,result);
         ArrayCopy(futureValues,prediction);

      //
      //
      //
      //
      //
      
      SetIndexDrawBegin(0,Bars-np-LastBar);
      SetIndexDrawBegin(1,Bars-nf-1);

   return(0); 
}

